<?php

class Quivers_Integration_Model_LogTracking
{
	protected $logEndpoint = 'logs/';

    public function session_start($order_detail, $time){
        $logData = [
            "order_detail" => $order_detail,
            "time" => $time
        ];
         $this->logging("SESSION START", $logData);
    }

    public function validate_api_call($request, $response, $start_time, $end_time){
        $logData = [
            "start_time" => $start_time,
            "end_time" => $end_time,
            "request" => $request,
            "response" => $response
        ];
        $this->logging("VALIDATE API CALL", $logData);
    }

    public function countries_api_call($request, $response, $start_time, $end_time){
     $logData = [
            "request" => $request,
            "response" => $response,
            "start_time" => $start_time,
            "end_time" => $end_time
        ];
     $this->logging("COUNTRIES API CALL", $logData);
    }

    public function payment_request($order_data, $payment_method, $time, $response, $success){
     $logData = [
            "order_data" => $order_data,
            "payment_method" => $payment_method,
            "time" => $time,
            "response" => $response,
            "success" => $success
        ];
     $this->logging("PAYMENT REQUEST", $logData);
    }

    public function session_end($order_detail, $time){
     $logData = [
            "order_detail" => $order_detail,
            "time" => $time
        ];
     $this->logging("SESSION END", $logData);
    }

   	public function logging($type, $data)
    {
        $quiversSandbox = Mage::getStoreConfig('quivers_integration/settings/quivers_sandbox_enabled');
        $baseUrl = 'https://middleware.quiverstest.com/profile/';
        if($quiversSandbox == 0) {
            $baseUrl = "https://middleware.quivers.com/profile/";
        }
        $quiversAPIKey = Mage::getStoreConfig('quivers_integration/settings/quivers_api_key');
        $logdata = [
    		"api_key" => "apiKey ".$quiversAPIKey,
    		"uuid" => uniqid(),
            "type" => $type,
    		"log_data" => $data
    	];
    	$logUrl = $baseUrl.$this->logEndpoint;
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$logUrl);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($logdata));
        $output=curl_exec($ch);
        curl_close ($ch);
        return $output;
    }
}